/*
Copyright 1990-2001 Sun Microsystems, Inc. All Rights Reserved.

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions: The above copyright notice and this
permission notice shall be included in all copies or substantial
portions of the Software.


THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE OPEN GROUP OR SUN MICROSYSTEMS, INC. BE LIABLE
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE EVEN IF
ADVISED IN ADVANCE OF THE POSSIBILITY OF SUCH DAMAGES.


Except as contained in this notice, the names of The Open Group and/or
Sun Microsystems, Inc. shall not be used in advertising or otherwise to
promote the sale, use or other dealings in this Software without prior
written authorization from The Open Group and/or Sun Microsystems,
Inc., as applicable.


X Window System is a trademark of The Open Group

OSF/1, OSF/Motif and Motif are registered trademarks, and OSF, the OSF
logo, LBX, X Window System, and Xinerama are trademarks of the Open
Group. All other trademarks and registered trademarks mentioned herein
are the property of their respective owners. No right, title or
interest in or to any trademark, service mark, logo or trade name of
Sun Microsystems, Inc. or its licensors is granted.

*/
#ifndef _LOCALLOOKUP_H_
#define _LOCALLOOKUP_H_

typedef enum {
  LOOKUP_UNMAPPED = 0,
  LOOKUP_MAPPED = 1
} LookupWindowState;

typedef struct _LocalLookupExt {
  LookupWindowState mapped;
  int startindex;
  int currentindex;		/* current focused index */
  int choice_per_window;
  int nrows;
  int ncolumns;
  int n_choices;
  LuRange *range;		/* just a reference */
  int nrange;
  int crange;
  int begin_range;
  int end_range;
  XPointer LUTable;
  int LUTableSize;
} LocalLookupExt;

extern void Ximp_Local_Lookup_Create(XicCommon ic);
extern void Ximp_Local_Lookup_Start(XicCommon ic);
extern void Ximp_Local_Lookup_Draw(XicCommon ic);
extern void Ximp_Local_Lookup_Done(XicCommon ic);
extern void Ximp_Local_Lookup_Destroy(XicCommon ic);

extern Bool Ximp_Local_Lookup_Button_Filter(XicCommon ic,
					    int index, XEvent *ev);
extern Bool Ximp_Local_Lookup_Input_Filter(XicCommon ic,
					   char *input, XEvent *ev);
extern Bool Ximp_Local_Lookup_Action_Filter(XicCommon ic,
					    ActionType action,
					    XEvent *ev);
#endif
